import 'package:better_mcfallout_bot/src/better_mcfallout_bot.dart';

abstract class IConnectedEvent {
  String get host;
  int get port;
  String get gameVersion;
  String get uuid;
  String get name;
}

class ConnectedEvent implements IConnectedEvent, IEvent {
  @override
  late final String gameVersion;
  @override
  late final String host;
  @override
  late final int port;
  @override
  late final String uuid;
  @override
  late final String name;

  ConnectedEvent(RawEvent event)
      : gameVersion = event.data['game_version'],
        host = event.data['host'],
        port = event.data['port'],
        uuid = event.data['uuid'],
        name = event.data['name'];
}
